/*
 * TV-Browser
 * Copyright (C) 04-2003 Martin Oberhauser (martin@tvbrowser.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * CVS information:
 *  $RCSfile$
 *   $Source$
 *     $Date: 2010-05-06 20:54:08 +0200 (Thu, 06 May 2010) $
 *   $Author: bananeweizen $
 * $Revision: 6617 $
 */

package devplugin;

/**
 * Defines the filtering behavior.
 */
public interface ProgramFilter {

  /**
   *
   * @param program the program to be checked
   * @return true, if the filter accepts the specified program
   */
	public boolean accept(final Program program);

	public String toString();

  /**
   *
   * @return the name of this filter
   */
	public String getName();

}